set sql dialect 3;
create database 'localhost:c:\invent.gdb'
  user 'sysdba'
  password 'masterkey'
  default character set WIN1251;

connect 'localhost:c:\invent.gdb'
  user 'SYSDBA'
  password 'masterkey'
  page_size 4096
  default charset WIN1251;

create domain parent_def as varchar(15) not null collate PXW_CYRL;
create domain id_def as varchar(3) not null collate PXW_CYRL;
create domain name_def as varchar(30) not null collate PXW_CYRL;
create domain leg_def as integer default 0 not null;

create table tree (
  parent parent_def,
  id id_def,
  full_id computed by (parent || id),
  legatees leg_def,
  name name_def,
  primary key (parent, id)
);

set term !! ;
CREATE TRIGGER TBI_GROUPS FOR GROUPS
ACTIVE BEFORE INSERT POSITION 0
as
begin
  if (new.parent <> '') then
  begin
    update tree O set O.legatees = O.legatees + 1 where O.full_id = new.parent;
  end
end
set term ; !!

set term !! ;
CREATE TRIGGER TBD_TREE FOR TREE
ACTIVE BEFORE DELETE POSITION 0
as
begin
  update tree O set O.legatees = O.legatees - 1 where O.full_id = old.parent;
  delete from tree 0 where 0.parent = old.full_id;
end !!
set term ; !!

set term !! ;
CREATE TRIGGER TBU_GROUPS FOR GROUPS
ACTIVE BEFORE UPDATE POSITION 0
as
begin
  if (old.parent <> new.parent) then
    begin
      update groups O set O.legatees = O.legatees - 1 where O.full_id = old.parent;
      update groups O set O.legatees = O.legatees + 1 where O.full_id = new.parent;
    end
end !!
set term ; !!

commit;
